// FullAccess
resource "azurerm_role_definition" "automation_fullaccess_definition" {
  name              = "automation-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Automation/register/action",
      "Microsoft.Automation/automationAccounts/agentRegistrationInformation/read",
      "Microsoft.Automation/automationAccounts/agentRegistrationInformation/regenerateKey/action",
      "Microsoft.Automation/operations/read",
      "Microsoft.Automation/automationAccounts/configurations/content/read",
      "Microsoft.Automation/automationAccounts/compilationjobs/write",
      "Microsoft.Automation/automationAccounts/compilationjobs/read",
      "Microsoft.Automation/automationAccounts/compilationjobs/write",
      "Microsoft.Automation/automationAccounts/compilationjobs/read",
      "Microsoft.Automation/automationAccounts/configurations/read",
      "Microsoft.Automation/automationAccounts/configurations/getCount/action",
      "Microsoft.Automation/automationAccounts/configurations/write",
      "Microsoft.Automation/automationAccounts/configurations/delete",
      "Microsoft.Automation/automationAccounts/nodes/reports/content/read",
      "Microsoft.Automation/automationAccounts/nodes/reports/read",
      "Microsoft.Automation/automationAccounts/hybridRunbookWorkerGroups/read",
      "Microsoft.Automation/automationAccounts/hybridRunbookWorkerGroups/delete",
      "Microsoft.Automation/automationAccounts/jobs/runbookContent/action",
      "Microsoft.Automation/automationAccounts/jobs/read",
      "Microsoft.Automation/automationAccounts/jobs/write",
      "Microsoft.Automation/automationAccounts/jobs/stop/action",
      "Microsoft.Automation/automationAccounts/jobs/suspend/action",
      "Microsoft.Automation/automationAccounts/jobs/resume/action",
      "Microsoft.Automation/automationAccounts/jobs/output/read",
      "Microsoft.Automation/automationAccounts/jobs/streams/read",
      "Microsoft.Automation/automationAccounts/jobs/streams/read",
      "Microsoft.Automation/automationAccounts/modules/read",
      "Microsoft.Automation/automationAccounts/modules/getCount/action",
      "Microsoft.Automation/automationAccounts/modules/write",
      "Microsoft.Automation/automationAccounts/modules/delete",
      "Microsoft.Automation/automationAccounts/connections/read",
      "Microsoft.Automation/automationAccounts/connections/getCount/action",
      "Microsoft.Automation/automationAccounts/connections/write",
      "Microsoft.Automation/automationAccounts/connections/delete",
      "Microsoft.Automation/automationAccounts/jobSchedules/read",
      "Microsoft.Automation/automationAccounts/jobSchedules/write",
      "Microsoft.Automation/automationAccounts/jobSchedules/delete",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/rawContent/action",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/read",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/write",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/delete",
      "Microsoft.Automation/automationAccounts/nodecounts/read",
      "Microsoft.Automation/automationAccounts/nodes/read",
      "Microsoft.Automation/automationAccounts/nodes/write",
      "Microsoft.Automation/automationAccounts/nodes/delete",
      "Microsoft.Automation/automationAccounts/objectDataTypes/fields/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/content/write",
      "Microsoft.Automation/automationAccounts/runbooks/content/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/undoEdit/action",
      "Microsoft.Automation/automationAccounts/runbooks/draft/operationResults/read",
      "Microsoft.Automation/automationAccounts/runbooks/read",
      "Microsoft.Automation/automationAccounts/runbooks/getCount/action",
      "Microsoft.Automation/automationAccounts/runbooks/write",
      "Microsoft.Automation/automationAccounts/runbooks/delete",
      "Microsoft.Automation/automationAccounts/runbooks/publish/action",
      "Microsoft.Automation/automationAccounts/schedules/read",
      "Microsoft.Automation/automationAccounts/schedules/getCount/action",
      "Microsoft.Automation/automationAccounts/schedules/write",
      "Microsoft.Automation/automationAccounts/schedules/delete",
      "Microsoft.Automation/automationAccounts/statistics/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/write",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/stop/action",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/suspend/action",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/resume/action",
      "Microsoft.Automation/automationAccounts/connectionTypes/read",
      "Microsoft.Automation/automationAccounts/connectionTypes/write",
      "Microsoft.Automation/automationAccounts/connectionTypes/delete",
      "Microsoft.Automation/automationAccounts/modules/activities/read",
      "Microsoft.Automation/automationAccounts/certificates/getCount/action",
      "Microsoft.Automation/automationAccounts/certificates/read",
      "Microsoft.Automation/automationAccounts/certificates/write",
      "Microsoft.Automation/automationAccounts/certificates/delete",
      "Microsoft.Automation/automationAccounts/credentials/read",
      "Microsoft.Automation/automationAccounts/credentials/getCount/action",
      "Microsoft.Automation/automationAccounts/credentials/write",
      "Microsoft.Automation/automationAccounts/credentials/delete",
      "Microsoft.Automation/automationAccounts/updateDeploymentMachineRuns/read",
      "Microsoft.Automation/automationAccounts/updateManagementPatchJob/read",
      "Microsoft.Automation/automationAccounts/linkedWorkspace/read",
      "Microsoft.Automation/automationAccounts/usages/read",
      "Microsoft.Automation/automationAccounts/watchers/watcherActions/write",
      "Microsoft.Automation/automationAccounts/watchers/watcherActions/read",
      "Microsoft.Automation/automationAccounts/watchers/watcherActions/delete",
      "Microsoft.Automation/automationAccounts/watchers/streams/read",
      "Microsoft.Automation/automationAccounts/watchers/write",
      "Microsoft.Automation/automationAccounts/watchers/read",
      "Microsoft.Automation/automationAccounts/watchers/delete",
      "Microsoft.Automation/automationAccounts/watchers/start/action",
      "Microsoft.Automation/automationAccounts/watchers/stop/action",
      "Microsoft.Automation/automationAccounts/webhooks/read",
      "Microsoft.Automation/automationAccounts/webhooks/write",
      "Microsoft.Automation/automationAccounts/webhooks/delete",
      "Microsoft.Automation/automationAccounts/webhooks/action",
      "Microsoft.Automation/automationAccounts/read",
      "Microsoft.Automation/automationAccounts/write",
      "Microsoft.Automation/automationAccounts/listKeys/action",
      "Microsoft.Automation/automationAccounts/delete",
      "Microsoft.Automation/automationAccounts/variables/read",
      "Microsoft.Automation/automationAccounts/variables/write",
      "Microsoft.Automation/automationAccounts/variables/delete",
      "Microsoft.Automation/automationAccounts/softwareUpdateConfigurations/write",
      "Microsoft.Automation/automationAccounts/softwareUpdateConfigurations/read",
      "Microsoft.Automation/automationAccounts/softwareUpdateConfigurations/delete",
      "Microsoft.Automation/automationAccounts/python2Packages/read",
      "Microsoft.Automation/automationAccounts/python2Packages/write",
      "Microsoft.Automation/automationAccounts/python2Packages/delete",
      "Microsoft.Automation/automationAccounts/python3Packages/read",
      "Microsoft.Automation/automationAccounts/python3Packages/write",
      "Microsoft.Automation/automationAccounts/python3Packages/delete",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "automation_readonly_definition" {
  name              = "automation-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Automation/automationAccounts/agentRegistrationInformation/read",
      "Microsoft.Automation/operations/read",
      "Microsoft.Automation/automationAccounts/configurations/content/read",
      "Microsoft.Automation/automationAccounts/compilationjobs/read",
      "Microsoft.Automation/automationAccounts/compilationjobs/read",
      "Microsoft.Automation/automationAccounts/configurations/read",
      "Microsoft.Automation/automationAccounts/nodes/reports/content/read",
      "Microsoft.Automation/automationAccounts/nodes/reports/read",
      "Microsoft.Automation/automationAccounts/hybridRunbookWorkerGroups/read",
      "Microsoft.Automation/automationAccounts/jobs/read",
      "Microsoft.Automation/automationAccounts/jobs/output/read",
      "Microsoft.Automation/automationAccounts/jobs/streams/read",
      "Microsoft.Automation/automationAccounts/jobs/streams/read",
      "Microsoft.Automation/automationAccounts/modules/read",
      "Microsoft.Automation/automationAccounts/connections/read",
      "Microsoft.Automation/automationAccounts/jobSchedules/read",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/read",
      "Microsoft.Automation/automationAccounts/nodecounts/read",
      "Microsoft.Automation/automationAccounts/nodes/read",
      "Microsoft.Automation/automationAccounts/objectDataTypes/fields/read",
      "Microsoft.Automation/automationAccounts/runbooks/content/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/operationResults/read",
      "Microsoft.Automation/automationAccounts/runbooks/read",
      "Microsoft.Automation/automationAccounts/schedules/read",
      "Microsoft.Automation/automationAccounts/statistics/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/read",
      "Microsoft.Automation/automationAccounts/connectionTypes/read",
      "Microsoft.Automation/automationAccounts/modules/activities/read",
      "Microsoft.Automation/automationAccounts/certificates/read",
      "Microsoft.Automation/automationAccounts/credentials/read",
      "Microsoft.Automation/automationAccounts/updateDeploymentMachineRuns/read",
      "Microsoft.Automation/automationAccounts/updateManagementPatchJob/read",
      "Microsoft.Automation/automationAccounts/linkedWorkspace/read",
      "Microsoft.Automation/automationAccounts/usages/read",
      "Microsoft.Automation/automationAccounts/watchers/watcherActions/read",
      "Microsoft.Automation/automationAccounts/watchers/streams/read",
      "Microsoft.Automation/automationAccounts/watchers/read",
      "Microsoft.Automation/automationAccounts/webhooks/read",
      "Microsoft.Automation/automationAccounts/read",
      "Microsoft.Automation/automationAccounts/variables/read",
      "Microsoft.Automation/automationAccounts/softwareUpdateConfigurations/read",
      "Microsoft.Automation/automationAccounts/python2Packages/read",
      "Microsoft.Automation/automationAccounts/python3Packages/read",
    ]

    not_actions = [
      "Microsoft.Automation/register/action",
      "Microsoft.Automation/automationAccounts/agentRegistrationInformation/regenerateKey/action",
      "Microsoft.Automation/automationAccounts/compilationjobs/write",
      "Microsoft.Automation/automationAccounts/compilationjobs/write",
      "Microsoft.Automation/automationAccounts/configurations/getCount/action",
      "Microsoft.Automation/automationAccounts/configurations/write",
      "Microsoft.Automation/automationAccounts/configurations/delete",
      "Microsoft.Automation/automationAccounts/hybridRunbookWorkerGroups/delete",
      "Microsoft.Automation/automationAccounts/jobs/runbookContent/action",
      "Microsoft.Automation/automationAccounts/jobs/write",
      "Microsoft.Automation/automationAccounts/jobs/stop/action",
      "Microsoft.Automation/automationAccounts/jobs/suspend/action",
      "Microsoft.Automation/automationAccounts/jobs/resume/action",
      "Microsoft.Automation/automationAccounts/modules/getCount/action",
      "Microsoft.Automation/automationAccounts/modules/write",
      "Microsoft.Automation/automationAccounts/modules/delete",
      "Microsoft.Automation/automationAccounts/connections/getCount/action",
      "Microsoft.Automation/automationAccounts/connections/write",
      "Microsoft.Automation/automationAccounts/connections/delete",
      "Microsoft.Automation/automationAccounts/jobSchedules/write",
      "Microsoft.Automation/automationAccounts/jobSchedules/delete",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/rawContent/action",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/write",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/delete",
      "Microsoft.Automation/automationAccounts/nodes/write",
      "Microsoft.Automation/automationAccounts/nodes/delete",
      "Microsoft.Automation/automationAccounts/runbooks/draft/content/write",
      "Microsoft.Automation/automationAccounts/runbooks/draft/undoEdit/action",
      "Microsoft.Automation/automationAccounts/runbooks/getCount/action",
      "Microsoft.Automation/automationAccounts/runbooks/write",
      "Microsoft.Automation/automationAccounts/runbooks/delete",
      "Microsoft.Automation/automationAccounts/runbooks/publish/action",
      "Microsoft.Automation/automationAccounts/schedules/getCount/action",
      "Microsoft.Automation/automationAccounts/schedules/write",
      "Microsoft.Automation/automationAccounts/schedules/delete",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/write",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/stop/action",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/suspend/action",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/resume/action",
      "Microsoft.Automation/automationAccounts/connectionTypes/write",
      "Microsoft.Automation/automationAccounts/connectionTypes/delete",
      "Microsoft.Automation/automationAccounts/certificates/getCount/action",
      "Microsoft.Automation/automationAccounts/certificates/write",
      "Microsoft.Automation/automationAccounts/certificates/delete",
      "Microsoft.Automation/automationAccounts/credentials/getCount/action",
      "Microsoft.Automation/automationAccounts/credentials/write",
      "Microsoft.Automation/automationAccounts/credentials/delete",
      "Microsoft.Automation/automationAccounts/watchers/watcherActions/write",
      "Microsoft.Automation/automationAccounts/watchers/watcherActions/delete",
      "Microsoft.Automation/automationAccounts/watchers/write",
      "Microsoft.Automation/automationAccounts/watchers/delete",
      "Microsoft.Automation/automationAccounts/watchers/start/action",
      "Microsoft.Automation/automationAccounts/watchers/stop/action",
      "Microsoft.Automation/automationAccounts/webhooks/write",
      "Microsoft.Automation/automationAccounts/webhooks/delete",
      "Microsoft.Automation/automationAccounts/webhooks/action",
      "Microsoft.Automation/automationAccounts/write",
      "Microsoft.Automation/automationAccounts/listKeys/action",
      "Microsoft.Automation/automationAccounts/delete",
      "Microsoft.Automation/automationAccounts/variables/write",
      "Microsoft.Automation/automationAccounts/variables/delete",
      "Microsoft.Automation/automationAccounts/softwareUpdateConfigurations/write",
      "Microsoft.Automation/automationAccounts/softwareUpdateConfigurations/delete",
      "Microsoft.Automation/automationAccounts/python2Packages/write",
      "Microsoft.Automation/automationAccounts/python2Packages/delete",
      "Microsoft.Automation/automationAccounts/python3Packages/write",
      "Microsoft.Automation/automationAccounts/python3Packages/delete",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "automation_noaccess_definition" {
  name              = "automation-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.Automation/register/action",
      "Microsoft.Automation/automationAccounts/agentRegistrationInformation/read",
      "Microsoft.Automation/automationAccounts/agentRegistrationInformation/regenerateKey/action",
      "Microsoft.Automation/operations/read",
      "Microsoft.Automation/automationAccounts/configurations/content/read",
      "Microsoft.Automation/automationAccounts/compilationjobs/write",
      "Microsoft.Automation/automationAccounts/compilationjobs/read",
      "Microsoft.Automation/automationAccounts/compilationjobs/write",
      "Microsoft.Automation/automationAccounts/compilationjobs/read",
      "Microsoft.Automation/automationAccounts/configurations/read",
      "Microsoft.Automation/automationAccounts/configurations/getCount/action",
      "Microsoft.Automation/automationAccounts/configurations/write",
      "Microsoft.Automation/automationAccounts/configurations/delete",
      "Microsoft.Automation/automationAccounts/nodes/reports/content/read",
      "Microsoft.Automation/automationAccounts/nodes/reports/read",
      "Microsoft.Automation/automationAccounts/hybridRunbookWorkerGroups/read",
      "Microsoft.Automation/automationAccounts/hybridRunbookWorkerGroups/delete",
      "Microsoft.Automation/automationAccounts/jobs/runbookContent/action",
      "Microsoft.Automation/automationAccounts/jobs/read",
      "Microsoft.Automation/automationAccounts/jobs/write",
      "Microsoft.Automation/automationAccounts/jobs/stop/action",
      "Microsoft.Automation/automationAccounts/jobs/suspend/action",
      "Microsoft.Automation/automationAccounts/jobs/resume/action",
      "Microsoft.Automation/automationAccounts/jobs/output/read",
      "Microsoft.Automation/automationAccounts/jobs/streams/read",
      "Microsoft.Automation/automationAccounts/jobs/streams/read",
      "Microsoft.Automation/automationAccounts/modules/read",
      "Microsoft.Automation/automationAccounts/modules/getCount/action",
      "Microsoft.Automation/automationAccounts/modules/write",
      "Microsoft.Automation/automationAccounts/modules/delete",
      "Microsoft.Automation/automationAccounts/connections/read",
      "Microsoft.Automation/automationAccounts/connections/getCount/action",
      "Microsoft.Automation/automationAccounts/connections/write",
      "Microsoft.Automation/automationAccounts/connections/delete",
      "Microsoft.Automation/automationAccounts/jobSchedules/read",
      "Microsoft.Automation/automationAccounts/jobSchedules/write",
      "Microsoft.Automation/automationAccounts/jobSchedules/delete",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/rawContent/action",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/read",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/write",
      "Microsoft.Automation/automationAccounts/nodeConfigurations/delete",
      "Microsoft.Automation/automationAccounts/nodecounts/read",
      "Microsoft.Automation/automationAccounts/nodes/read",
      "Microsoft.Automation/automationAccounts/nodes/write",
      "Microsoft.Automation/automationAccounts/nodes/delete",
      "Microsoft.Automation/automationAccounts/objectDataTypes/fields/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/content/write",
      "Microsoft.Automation/automationAccounts/runbooks/content/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/undoEdit/action",
      "Microsoft.Automation/automationAccounts/runbooks/draft/operationResults/read",
      "Microsoft.Automation/automationAccounts/runbooks/read",
      "Microsoft.Automation/automationAccounts/runbooks/getCount/action",
      "Microsoft.Automation/automationAccounts/runbooks/write",
      "Microsoft.Automation/automationAccounts/runbooks/delete",
      "Microsoft.Automation/automationAccounts/runbooks/publish/action",
      "Microsoft.Automation/automationAccounts/schedules/read",
      "Microsoft.Automation/automationAccounts/schedules/getCount/action",
      "Microsoft.Automation/automationAccounts/schedules/write",
      "Microsoft.Automation/automationAccounts/schedules/delete",
      "Microsoft.Automation/automationAccounts/statistics/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/read",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/write",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/stop/action",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/suspend/action",
      "Microsoft.Automation/automationAccounts/runbooks/draft/testJob/resume/action",
      "Microsoft.Automation/automationAccounts/connectionTypes/read",
      "Microsoft.Automation/automationAccounts/connectionTypes/write",
      "Microsoft.Automation/automationAccounts/connectionTypes/delete",
      "Microsoft.Automation/automationAccounts/modules/activities/read",
      "Microsoft.Automation/automationAccounts/certificates/getCount/action",
      "Microsoft.Automation/automationAccounts/certificates/read",
      "Microsoft.Automation/automationAccounts/certificates/write",
      "Microsoft.Automation/automationAccounts/certificates/delete",
      "Microsoft.Automation/automationAccounts/credentials/read",
      "Microsoft.Automation/automationAccounts/credentials/getCount/action",
      "Microsoft.Automation/automationAccounts/credentials/write",
      "Microsoft.Automation/automationAccounts/credentials/delete",
      "Microsoft.Automation/automationAccounts/updateDeploymentMachineRuns/read",
      "Microsoft.Automation/automationAccounts/updateManagementPatchJob/read",
      "Microsoft.Automation/automationAccounts/linkedWorkspace/read",
      "Microsoft.Automation/automationAccounts/usages/read",
      "Microsoft.Automation/automationAccounts/watchers/watcherActions/write",
      "Microsoft.Automation/automationAccounts/watchers/watcherActions/read",
      "Microsoft.Automation/automationAccounts/watchers/watcherActions/delete",
      "Microsoft.Automation/automationAccounts/watchers/streams/read",
      "Microsoft.Automation/automationAccounts/watchers/write",
      "Microsoft.Automation/automationAccounts/watchers/read",
      "Microsoft.Automation/automationAccounts/watchers/delete",
      "Microsoft.Automation/automationAccounts/watchers/start/action",
      "Microsoft.Automation/automationAccounts/watchers/stop/action",
      "Microsoft.Automation/automationAccounts/webhooks/read",
      "Microsoft.Automation/automationAccounts/webhooks/write",
      "Microsoft.Automation/automationAccounts/webhooks/delete",
      "Microsoft.Automation/automationAccounts/webhooks/action",
      "Microsoft.Automation/automationAccounts/read",
      "Microsoft.Automation/automationAccounts/write",
      "Microsoft.Automation/automationAccounts/listKeys/action",
      "Microsoft.Automation/automationAccounts/delete",
      "Microsoft.Automation/automationAccounts/variables/read",
      "Microsoft.Automation/automationAccounts/variables/write",
      "Microsoft.Automation/automationAccounts/variables/delete",
      "Microsoft.Automation/automationAccounts/softwareUpdateConfigurations/write",
      "Microsoft.Automation/automationAccounts/softwareUpdateConfigurations/read",
      "Microsoft.Automation/automationAccounts/softwareUpdateConfigurations/delete",
      "Microsoft.Automation/automationAccounts/python2Packages/read",
      "Microsoft.Automation/automationAccounts/python2Packages/write",
      "Microsoft.Automation/automationAccounts/python2Packages/delete",
      "Microsoft.Automation/automationAccounts/python3Packages/read",
      "Microsoft.Automation/automationAccounts/python3Packages/write",
      "Microsoft.Automation/automationAccounts/python3Packages/delete",
    ]
  }
}
